﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

using System.Linq;

using Vintagestory.API.Common.Entities;
using Vintagestory.API.MathTools;

using ProtoBuf;

namespace Automap
{
	/// <summary>
	/// Actual Physical Point in space - that is interesting.
	/// </summary>
	[ProtoContract]
	public struct EntityOfInterest
	{
		[ProtoMember(1)]
		public string Name;

		[ProtoMember(2)]
		public string Notes;

		[ProtoMember(3)]
		public BlockPos Location;

		[ProtoMember(4)]
		public DateTime Timestamp;

		[ProtoMember(5)]
		public long EntityId;
	}

	/// <summary>
	/// Entities of interest.
	/// </summary>
	/// <remarks>Tracked by ID - these never leave.</remarks>
	public class EntitiesOfInterest : KeyedCollection<long, EntityOfInterest>
	{

		internal void AddReplace(EntityOfInterest entity)
		{
			if (Contains(entity.EntityId))
				Remove(entity.EntityId);

			Add(entity);
		}

		protected override long GetKeyForItem(EntityOfInterest item)
			=> item.EntityId;
	}
}

