﻿using System;
using System.Collections.ObjectModel;

using Vintagestory.API.Common;
using Vintagestory.API.MathTools;

using ProtoBuf;

namespace Automap
{
	/// <summary>
	/// Actual Physical Point in space - that is interesting.
	/// </summary>
	[ProtoContract]
	public struct PointOfInterest
	{
		[ProtoMember(1)]
		public string Name;

		[ProtoMember(2)]
		public string Notes;

		[ProtoMember(3)]
		public BlockPos Location;

		[ProtoMember(4)]
		public DateTime Timestamp;
	}

	public class PointsOfInterest : KeyedCollection<BlockPos, PointOfInterest>
	{
		protected override BlockPos GetKeyForItem(PointOfInterest item)
			=> item.Location;

		internal void AddReplace(PointOfInterest poi)
		{
			if (Contains(poi.Location))
				Remove(poi.Location);

			Add(poi);
		}
	}

}

